/* This program is Copyright © 2009-2018 Charo I. del Genio */

/* Licensed under the Academic Free License version 3.0

1) Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright,
   to do the following:
    a) to reproduce the Original Work in copies, either alone or as part
       of a collective work;
    b) to translate, adapt, alter, transform, modify, or arrange the Original
       Work, thereby creating derivative works ("Derivative Works") based
       upon the Original Work;
    c) to distribute or communicate copies of the Original Work and
       Derivative Works to the public, under any license of your choice that
       does not contradict the terms and conditions, including Licensor's
       reserved rights and remedies, in this Academic Free License;
    d) to perform the Original Work publicly; and
    e) to display the Original Work publicly.

2) Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or
   controlled by the Licensor that are embodied in the Original Work as
   furnished by the Licensor, for the duration of the patents, to make, use,
   sell, offer for sale, have made, and import the Original Work and
   Derivative Works.

3) Grant of Source Code License. The term "Source Code" means the preferred
   form of the Original Work for making modifications to it and all available
   documentation describing how to modify
   the Original Work. Licensor agrees to provide a machine-readable copy of
   the Source Code of the Original Work along with each copy of the Original
   Work that Licensor distributes. Licensor reserves the right to satisfy
   this obligation by placing a machine-readable copy of the Source Code in
   an information repository reasonably calculated to permit inexpensive
   and convenient access by You for as long as Licensor continues to
   distribute the Original Work.

4) Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell,
   offer for sale, have made, or import embodiments of any patent claims other
   than the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

5) External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by
   anyone other than You, whether those works are distributed or communicated
   to those persons or made available as an application intended for use over
   a network. As an express condition for the grants of license hereunder, You
   must treat any External Deployment by You of the Original Work or a
   Derivative Work as a distribution under section 1(c).

6) Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and
   any descriptive text identified therein as an "Attribution Notice." You
   must cause the Source Code for any Derivative Works that You create to
   carry a prominent Attribution Notice reasonably calculated to inform
   recipients that You have modified the Original Work.

7) Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that
   the copyright in and to the Original Work and the patent rights granted
   herein by Licensor are owned by the Licensor or are sublicensed to You
   under the terms of this License with the permission of the contributor(s)
   of those copyrights and patent rights. Except as expressly stated in the
   immediately preceding sentence, the Original Work is provided under this
   License on an "AS IS" BASIS and WITHOUT WARRANTY, either express or
   implied, including, without limitation, the warranties of non-infringement,
   merchantability or fitness for a particular purpose. THE ENTIRE RISK AS TO
   THE QUALITY OF THE ORIGINAL WORK IS WITH YOU. This DISCLAIMER OF WARRANTY
   constitutes an essential part of this License. No license to the Original
   Work is granted by this License except under this disclaimer.

8) Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License
   or the use of the Original Work including, without limitation, damages for
   loss of goodwill, work stoppage, computer failure or malfunction, or any and
   all other commercial damages or losses. This limitation of liability shall
   not apply to the extent applicable law prohibits such limitation.

9) Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or
   communicate copies of the Original Work or a Derivative Work, You must make
   a reasonable effort under the circumstances to obtain the express assent of
   recipients to the terms of this License. This License conditions your rights
   to undertake the activities listed in Section 1, including your right to
   create Derivative Works based upon the Original Work, and doing so without
   honoring these terms and conditions is prohibited by copyright law and
   international treaty. Nothing in this License is intended to affect
   copyright exceptions and limitations (including "fair use" or "fair
   dealing"). This License shall terminate immediately and You may no longer
   exercise any of the rights granted to You by this License upon your failure
   to honor the conditions in Section 1(c).

10) Termination for Patent Action. This License shall terminate automatically
    and You may no longer exercise any of the rights granted to You by this
    License as of the date You commence an action, including a cross-claim or
    counterclaim, against Licensor or any licensee alleging that the Original
    Work infringes a patent. This termination provision shall not apply for an
    action alleging patent infringement by combinations of the Original Work
    with other software or hardware.

11) Jurisdiction, Venue and Governing Law. Any action or suit relating to this
    License may be brought only in the courts of a jurisdiction wherein the
    Licensor resides or in which Licensor conducts its primary business, and
    under the laws of that jurisdiction excluding its conflict-of-law
    provisions. The application of the United Nations Convention on Contracts
    for the International Sale of Goods is expressly excluded. Any use of the
    Original Work outside the scope of this License or after its termination
    shall be subject to the requirements and penalties of copyright or patent
    law in the appropriate jurisdiction. This section shall survive the
    termination of this License.

12) Attorneys' Fees. In any action to enforce the terms of this License or
    seeking damages relating thereto, the prevailing party shall be entitled to
    recover its costs and expenses, including, without limitation, reasonable
    attorneys' fees and costs incurred in connection with such action,
    including any appeal of such action. This section shall survive the
    termination of this License.

13) Miscellaneous. If any provision of this License is held to be
    unenforceable, such provision shall be reformed only to the extent
    necessary to make it enforceable.

14) Definition of "You" in This License. "You" throughout this License, whether
    in upper or lower case, means an individual or a legal entity exercising
    rights under, and complying with all of the terms of, this License. For
    legal entities, "You" includes any entity that controls, is controlled by,
    or is under common control with you. For purposes of this definition,
    "control" means (i) the power, direct or indirect, to cause the direction
    or management of such entity, whether by contract or otherwise, or (ii)
    ownership of fifty percent (50%) or more of the outstanding shares, or
    (iii) beneficial ownership of such entity.

15) Right to Use. You may use the Original Work in all ways not otherwise
    restricted or conditioned by this License or by law, and Licensor promises
    not to interfere with or be responsible for such uses by You.

16) Modification of This License. This License is Copyright © 2005 Lawrence
    Rosen. Permission is granted to copy, distribute, or communicate this
    License without modification. Nothing in this License permits You to modify
    this License as applied to the Original Work or to Derivative Works.
    However, You may modify the text of this License and copy, distribute or
    communicate your modified version (the "Modified License") and apply it to
    other original works of authorship subject to the following conditions: (i)
    You may not indicate in any way that your Modified License is the "Academic
    Free License" or "AFL" and you may not use those names in the name of your
    Modified License; (ii) You must replace the notice specified in the first
    paragraph above with the notice "Licensed under <insert your license name
    here>" or with a notice of your own that is not confusingly similar to the
    notice in this License; and (iii) You may not claim that your original
    works are open source software unless your Modified License has been
    approved by Open Source Initiative (OSI) and You comply with its license
    review and certification process.
*/



#include"GSampler.h"



/* Graph sampler initializer */
void gsaminit(const int *seq, const int nodes)
{
	int i, n=0;
	unsigned long int stubs = 0;
	
	do n++;
	while (n<nodes && seq[n]!=0);
	
	/* Memory allocations */
	orig.degree      = calloc(n,sizeof(int));								// Original sequence
	orig.label       = calloc(n,sizeof(int));								// Original node labels
	orig.forbidden   = calloc(n,sizeof(int));								// Original forbidden status labels
	indseq.degree    = calloc(n,sizeof(int));								// Work sequence
	indseq.label     = calloc(n,sizeof(int));								// Work sequence labels
	indseq.forbidden = calloc(n,sizeof(int));								// Work sequence forbidden status labels
	allowed          = calloc(n,sizeof(int));								// Allowed nodes
	newseq           = calloc(n,sizeof(int));								// D' sequence
	xk               = calloc(n,sizeof(int));								// Crossing indices hash table
	
	/* Initializtions of sequences */
	for (i=0; i<n; i++) {
		orig.degree[i]     = seq[i];
		orig.label[i]      = i;
		orig.forbidden[i]  = 0;
		stubs             += seq[i];
	}
	
	/* Initialization of sample */
	sample.list    = malloc(n*sizeof(int*));								// Adjacency list
	sample.list[0] = calloc(stubs,sizeof(int));
	for (i=1; i<n; i++) sample.list[i] = sample.list[i-1]+orig.degree[i-1];
	orlen = n;
	
	return;
}



/* Graph sampler cleanup */
void gsamclean(void)
{
	
	free(orig.degree);
	free(orig.label);
	free(orig.forbidden);
	free(indseq.degree);
	free(indseq.label);
	free(indseq.forbidden);
	free(allowed);
	free(newseq);
	free(xk);
	free(sample.list[0]);
	free(sample.list);
	
	return;
}



/* Graph sampler */
graph gsam(double (*rng)(void), const int stsm)
{
	int i, j;
	
	len = orlen;
	for (i=0; i<len; i++) {
		indseq.degree[i]    = orig.degree[i];
		indseq.label[i]     = i;
		indseq.forbidden[i] = 0;
	}
	offset = 0;
	sample.weight = 0.0;
	
	build(rng,stsm);
	
	return sample;
}



/* Recursively places all the possible links in the graph */
static void build(double (*rng)(void), const int stsm)
{
	int i, j, alll;
	unsigned long int ext, count=0, restubs=0;
	
	if (stsm) {
		for (j=1; j<len; j++) restubs += indseq.degree[offset+j];
		ext = restubs*rng();
		j = 0;
		do {
			j++;
			count += indseq.degree[offset+j];
		} while (count<=ext);
		sample.weight += log(restubs)-lgamma(indseq.degree[offset]+1)-log(indseq.degree[offset+j]);									// Start computing the weight
	} else {
		j = ((int) ((len-1)*rng()))+1;
		sample.weight += log(len-1)-lgamma(indseq.degree[offset]+1);
	}
	sample.list[indseq.label[offset]][orig.degree[indseq.label[offset]]-indseq.degree[offset]] = indseq.label[offset+j];			// Connect the node to the hub
	sample.list[indseq.label[offset+j]][orig.degree[indseq.label[offset+j]]-indseq.degree[offset+j]] = indseq.label[offset];
	indseq.degree[offset]--;																										// Reduce the degree of the hub
	indseq.degree[offset+j]--;														 												// Reduce tuhe degree of the target node
	condsort(j);																													// Reorder the sequence if needed.
	
	while (indseq.degree[offset]>0) {																								// If the hub node still has stubs
		alll=0;																														// Reset the size of the allowed nodes set
		restubs=0;
		allow(&alll,&restubs);																										// Build the set of allowed nodes
		if (stsm) {
			ext = restubs*rng();
			count = 0;
			i = -1;
			do {
				i++;
				count += indseq.degree[offset+allowed[i]];
			} while (count<=ext);
			j = allowed[i];
			sample.weight += log(restubs)-log(indseq.degree[offset+j]);																// Update the weight
		} else {
			sample.weight += log(alll);
			j = allowed[((int) (alll*rng()))];
		}
		sample.list[indseq.label[offset]][orig.degree[indseq.label[offset]]-indseq.degree[offset]] = indseq.label[offset+j];		// Connect the node to the hub
		sample.list[indseq.label[offset+j]][orig.degree[indseq.label[offset+j]]-indseq.degree[offset+j]] = indseq.label[offset];
		indseq.degree[offset]--;																									// Reduce the degree of the hub
		indseq.degree[offset+j]--;														 											// Reduce tuhe degree of the target node
		condsort(j);																												// Reorder the sequence if needed.
	}
	
	if (len>1) {																													// If there are more nodes to be connected
		offset++;																													// Update the memory offset
		len--;																														// Reduce the length of the sequence
		for (j=0; j<len; j++) indseq.forbidden[offset+j] = 0;																		// Clear the forbidden flags
		build(rng,stsm);																											// and keep sampling.
	}
	
	return;
}



/* Builds the set of the nodes which we are allowed to connect to */
static void allow(int *alll, unsigned long int *restubs)
{
	int stop=0, faildeg, count=0, lastdeg, flag=0, k=0, j=1, t, dumdeg, firstdeg, curdeg=-1, moven=0, tarpos, oripos, check, degchk, index, indexcopy;
	long int degsum, minsum;
	
	
    /* Start making a copy of the sequence.
       Add the leftmost adjacency set to the allowed node set.
       Also decrease the degrees of the nodes in the copy sequence
       which are added to the set and make them forbidden */
	while (count<indseq.degree[offset] && j<len) {
		*(newseq+j-1) = indseq.degree[offset+j];
		if (!indseq.forbidden[offset+j]) {
			(*(newseq+j-1))--;
			(*alll)++;
			*(allowed+(*alll)-1) = j;
			(*restubs) += indseq.degree[offset+j];
			count++;
			if (curdeg!=*(newseq+j-1)) {
				curdeg = (*(newseq+j-1));
				firstdeg = j-1;
			}
		} else {
			if (j>1) {
				if (*(newseq+j-1)>*(newseq+j-2)) {
					dumdeg = *(newseq+firstdeg);
					*(newseq+firstdeg) = *(newseq+j-1);
					*(newseq+j-1) = dumdeg;
					firstdeg++;
				}
			} else {
				firstdeg = 0;
				curdeg = *(newseq);
			}
		}
		j++;
	}
	lastdeg = indseq.degree[offset+(*(allowed+(*alll)-1))];												// Degree of the last node in the leftmost adjacency set
	
	/* Revert the degree (in the copy sequence) of the last node added to the set.
	   If needed, also add to the allowed set all the nodes that are not restricted and have
	   the same degree of the last node in the leftmost adjacency set and keep copying the sequence */
	check = (*(allowed+(*alll)-1))-1;
	(*(newseq+check))++;
	if (check>0) degchk = *(newseq+check-1);
	else degchk=-1;
	while (j<len && (indseq.degree[offset+j]==lastdeg || indseq.forbidden[offset+j])) {
		*(newseq+j-1) = indseq.degree[offset+j];
		if (!indseq.forbidden[offset+j]) {
			(*alll)++;
			*(allowed+(*alll)-1) = j;
			(*restubs) += indseq.degree[offset+j];
		}
		j++;
	}
	
	if (j<len) {																						// If there are more nodes left
	    for (index=j; index<len; index++) *(newseq+index-1) = indseq.degree[offset+index];				// Finish copying the sequence
	    *(newseq+len-1) = 1;																			// Hub at the end with degree 1
	    
	    /* If needed, quickly reorder the sequence */
		if (degchk!=-1) {
			oripos = check;
			while (check<len && degchk<*(newseq+check)) {moven++;check++;}
			if (moven>0) {
				degchk = *(newseq+oripos);
				tarpos = oripos-1;
				while (tarpos>=0 && degchk>*(newseq+(tarpos))) tarpos--;
				tarpos++;
				for (t=oripos-1; t>=tarpos; t--) *(newseq+t+moven)=*(newseq+t);
				for (t=0; t<moven; t++) *(newseq+tarpos+t) = degchk;
			}
		}
		
	    /* Build the hash table for the crossing indices */
	    indexcopy=-1;
	    for (index=len-1; index>=(*newseq); index--) *(xk+index) = 0;
	    for (index=1; index<len; index++) for (indexcopy=(*(newseq+index-1))-1; indexcopy>=(*(newseq+index)); indexcopy--) *(xk+indexcopy) = index;
	    for (index=indexcopy; index>=0; index--) *(xk+index) = len;
	    
	    /* Start the E-G test */
		degsum  = (*newseq);
		minsum  = len-1;
		faildeg = 0;																					// If L=R, then the maximum fail degree is the degree of the next node or 1 less than the
		if (degsum==minsum) {																			// degree of the last node in the leftmost adjacency set of the hub, whichever is smaller.
			if ((*(newseq+1))<lastdeg) faildeg = (*(newseq+1));											// If instead L=R-1, then the fail degree for this value of k is either the degree of the
			else faildeg = lastdeg-1;																	// node whose index is the crossing index for (k+1) or the degree of the next node,
			stop = 1;																					// depending on whether the crossing index for (k+1) is greater than k or not, respectively.
		} else if (degsum==(minsum-1)) if (lastdeg>1) faildeg = 1;										// For k=0, the case L=R-1 reduces to a fail degree of 1.
		
		if (len>=3) {																					// If there are more nodes, keep testing as long as necessary, as described above
			while ((!stop) && (k<(len-2))) {
				k++;
				degsum += (*(newseq+k));
				if ((*(xk+k))<k+1) flag = 1;
				if (!flag) minsum += (*(xk+k))-1;
				else minsum += (2*k-(*(newseq+k)));
				if (degsum==minsum) {
					if ((*(newseq+k+1))<lastdeg) faildeg = (*(newseq+k+1));
					else faildeg = lastdeg-1;
					stop = 1;
				} else if (degsum==(minsum-1)) {
					if ((*(xk+k+1))>k) {
						if ( (*(newseq+(*(xk+k+1))))>=faildeg ) faildeg = (*(newseq+(*(xk+k+1))));
						else stop = 1;
					} else {
						if ( (*(newseq+k+1))>=faildeg ) faildeg = (*(newseq+k+1));
						else stop = 1;
					}
				}
			}
		}
		
		/* Add to the allowed set all the non-forbidden nodes
		   whose degree is greater than the maximum fail degree */
		while (j<len) {
			if ( !indseq.forbidden[offset+j] && indseq.degree[offset+j]>faildeg ) {
				(*alll)++;
				*(allowed+(*alll)-1) = j;
				(*restubs) += indseq.degree[offset+j];
			}
			j++;
		}
	}
	
	return;
}
